﻿using Bridge;
using System;
using System.Reflection;

namespace DuckInterface
{
    public static class InterfaceCreator
    {
        public static TInterface Create<TInterface>(string serviceName)
        {
            var interfaceType = typeof(TInterface);
            if (interfaceType.IsNested) throw new NotSupportedException("Not support nested type define");

            var interfaceMethodInfos = interfaceType.GetMethods(BindingFlags.Public | BindingFlags.Instance);

            object si = new { };

            foreach (var methodInfo in interfaceMethodInfos)
            {
                var bridgeInterfaceMethodName = $"{interfaceType.FullName}.{methodInfo.Name}".Replace('.', '$');

                var implement = new Action(() =>
                {
                    Console.WriteLine($"GEN:{methodInfo.Name} @ {serviceName}");
                });

                //interface alias
                si[bridgeInterfaceMethodName] = implement;
                si[methodInfo.Name] = implement;
            }

            return DuckCast<TInterface>(si);
        }

        [Template("{instance}")]
        private static extern T DuckCast<T>(object instance);
    }
}
